const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const customers = sequelize.define(
    'customers',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

customer_code: {
        type: DataTypes.TEXT,
      
      

      },

name: {
        type: DataTypes.TEXT,
      
      

      },

type: {
        type: DataTypes.ENUM,
      
      

        values: [

"residential",


"commercial",


"builder",


"developer",


"other"

        ],

      },

email: {
        type: DataTypes.TEXT,
      
      

      },

phone: {
        type: DataTypes.TEXT,
      
      

      },

billing_address: {
        type: DataTypes.TEXT,
      
      

      },

shipping_address: {
        type: DataTypes.TEXT,
      
      

      },

tax_number: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"active",


"inactive",


"on_hold"

        ],

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  customers.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






    db.customers.hasMany(db.contacts, {
      as: 'contacts_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });


    db.customers.hasMany(db.leads, {
      as: 'leads_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });


    db.customers.hasMany(db.quotes, {
      as: 'quotes_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });



    db.customers.hasMany(db.projects, {
      as: 'projects_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });


















    db.customers.hasMany(db.invoices, {
      as: 'invoices_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });



    db.customers.hasMany(db.payments, {
      as: 'payments_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });




//end loop






    db.customers.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.customers.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return customers;
};


